﻿using System;
using System.CodeDom.Compiler;
using System.Reflection;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private
        
        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.Title = "CodeDomProvider 클래스 : 런타임에서 C# 코드를 동적으로 컴파일하고 DLL 파일 생성하기";

            CompilerParameters parameters = new CompilerParameters();

            parameters.GenerateExecutable = false;

            parameters.OutputAssembly = "d:\\TestSample.dll";

            string code = @"
namespace TestProject
{
    public class TestClass
    {
        public static int Value = 100;
    }
}
";

            CompilerResults result = CodeDomProvider.CreateProvider("CSharp").CompileAssemblyFromSource(parameters, code);

            Assembly assembly = Assembly.LoadFrom("d:\\TestSample.dll");

            Type type = assembly.GetType("TestProject.TestClass");

            FieldInfo fieldInfo = type.GetField("Value");

            object value = fieldInfo.GetValue(null);

            Console.WriteLine(value);
        }

        #endregion
    }
}